#!/usr/bin/perl
&parse_command_line;
print "newslist v 0.02,[k]\n\n" if($debug >0);
if(($ARGS{'c'} eq "") or ($ARGS{'l'} eq "")) {
	print "Usage:\n\tsendlist -c <config file> -l <list name>\n";
	die "\n";
}
$debug=$ARGS{'d'};
$listname=$ARGS{'l'};
$nntp_prefix="lists";
open(CONFIG,$ARGS{'c'}) or die "! Can't open file $ARGS{'c'}\n";
$isGotHalf=0;     # half operation
while(<CONFIG>) {
	chop();
	if(/^#/ or /^$/) {next;}        # entire string is comment or empty
	if(/(.*)#(.*)/) {$_=$1;}        # piece of string - comment
	if(/(.*)\\/) {
		$option="$option$1"; $isGotHalf=1;
	} else {
		if($isGotHalf) {
			$option="$option$_"
		} else {
			$option=$_;
		}
		if($option=~/LIST(.*)/) {
			@options=split(/\]/,$1);
			for($i=0;$i<=$#options and $_=$options[$i]; $i++) {
				$_=$options[$i];
				print "list option:$_\n" if($debug>3);
				if(/\[(.*)/ or /(.*)\]/) {$_=$1;}
				$lname=$_ if($i==0);
				if(/(.*):(.*)/) {$$lname{$1}=$2;}
		    }
		} elsif($option=~/USER(.*)/) {
			$_=$1;
			#!/usr/bin/perl
			/\[(\S*)(\])(.*)/;
			$user=$1;
			$remain=$3;
			$pattern="lists:$listname";
			if($remain=~/$pattern/) {
				if($#users==-1) {
					$users[0]=$user;
				} else {
					$users[$#users+1]=$user;
				}
		    }
		} elsif($option=~/NNTP_PREFIX\s(.*)/) {
			$nntp_prefix=$1;
		}
		$option="";
	}
} #  CONFIG
close(CONFIG);
print "list <$listname>  Reply-to : ",$$listname{"Reply-to"},"\n" if($debug>1);
print "list <$listname> NNTP host : ",$$listname{"NNTP"},"\n\n" if($debug>1);

$reply_to=$$listname{"Reply-to"};
$nntp_host=$$listname{"NNTP"};

$isBody=0;
$body=""; $from=""; $subj="";
$headers=0;
$body=0;

while(1) {
	$_=<STDIN>;
	if(/From\s/ or eof(STDIN)) {
		if($from ne "" and $subj ne "" and $bodytxt ne "") {
			&send_message;
		}
		if(eof(STDIN)) {last;}
		print "**begin\n" if($debug>4);
		$headers=1;
		$body=0;
		$bodytxt="";
		$from="";
		$subj="";
	} elsif(/^\n/) {
		if($headers==1) {
			$headers=0;
			$body=1;
		}
	}
	chop();
	if($headers==1) {
		if(/From:(.*)/ and $from eq "") {
			$from=$1;
		} elsif(/Subject:(.*)/) { # always last 
			$subj=$1;
		}
		print "H : $_\n" if(debug>4);
	} elsif($body==1) {
		$bodytxt="$bodytxt$_\n";
		print "B : $_\n" if($debug>4);
	} else {
		print "? : $_\n" if($debug>4);
	}
}


#  SubRoutines /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\|
sub parse_command_line {
	if($ARGV[0] eq "-h") {&this_programm_help; exit(0);}
	local($i);
	for($i=0; $i<$#ARGV and $_=$ARGV[$i]; $i++) {
		if(/-(.*)/) {
			$ARGS{$1}=$ARGV[$i+1];
		}
	}
}

sub send_news_article {
	# parameters are : 
	#	0 	NNTP host
	#   	1   	NNTP service name (usually `nntp')
	#   	2   	Newsgroup name
	# 	4	From
	#	5	Subject 
	#	6	Body
	
	local($nntp_host,$service_name,$newsgroup,$from,$subj,$body,$reply_to,$com);	
	
	$nntp_host=		$_[0];
	$service_name=	$_[1];
	$newsgroup=		$_[2];
	$from=			$_[3];
	$subj=			$_[4];
	$body=			$_[5];
	$reply_to=		$_[6];
	
	use Socket; # i fond of this fantastic perl !
	
	$proto = getprotobyname('tcp');
	socket(Socket_Handle, PF_INET, SOCK_STREAM, $proto);
	$port = getservbyname($service_name,'tcp');
	$sin = sockaddr_in($port,inet_aton($nntp_host));
	connect(Socket_Handle,$sin);
	sleep(0.01);

	syswrite(Socket_Handle, "post\n",length("post\n"));
	sleep(0.01);

	# prepare full string to send
	$com="Newsgroups: $newsgroup\nFrom: $from\nSubject: $subj\n\n$body\n                                   -----\n* This mailing list Reply-To address is $reply_to \n.\nquit\n";
	print "Sending NEWS to site $nntp_host port $port: \n*** begin news text\n$com\n*** end news text\n" if($debug>2);
	# send it to a server
	syswrite(Socket_Handle, $com,length($com));
	sleep(1);
	# close connection to nntp server
	close(Socket_Handle);
}

sub send_message {
	print "Ok -- Letter from : $from\n" if($debug>2);               # was debug 
	print "Ok -- Letter subj : $subj\n" if($debug>2);
	print "\n*** begin message body\n$bodytxt\n*** end message body\n\n" if($debug>2);
	if($nntp_host ne "") {
		print "sending article to newsgroup $nntp_prefix.$listname on server $nntp_host\n" if($debug>1);
		send_news_article($nntp_host,"nntp","$nntp_prefix.$listname",$from,$subj,$bodytxt,$reply_to);
	} else {
		print "no news server defined \n" if ($debug>5); 
	}
	if($#users!=-1) {
		open(SENDMAIL,"|/usr/sbin/sendmail -bs > /dev/null") or die "! Can't create pipe to /usr/sbin/sendmail\n";
		for($i=0; $i<=$#users and $_=$users[$i]; $i++) {
			print "Sending message to user $_\n" if($debug>1);
			print "S->MAIL FROM: $reply_to\n" if($debug>5);
			print SENDMAIL "MAIL FROM: $reply_to\n";
			print "S->RCPT TO: $_\n" if($debug>5);
			print SENDMAIL "RCPT TO: $_\n";
			print "S->DATA\n" if($debug>5);
			print SENDMAIL "DATA\n";
			print "S->Subject: $subj\n" if($debug>5);
			print SENDMAIL "Subject: $subj\n";
			print "S:\n->-- Originally from : $from --\n\n" if($debug>5);
			print SENDMAIL "\n-- Originally from : $from --\n\n";
			print "S->",$bodytxt if($debug>5);
			print SENDMAIL $bodytxt;
			print SENDMAIL "\n.\n";
		}
		print SENDMAIL "QUIT\n";
		close(SENDMAIL);
	}
}
